#
# spec file for package gpg (Version 1.2.2rc1)
#
# Copyright (c) 2003 SuSE Linux AG, Nuernberg, Germany.
# This file and all modifications and additions to the pristine
# package are under the same license as the package itself.
#
# Please submit bugfixes or comments via http://www.suse.de/feedback/
#

# neededforbuild  expect gdbm openldap2 openldap2-client openldap2-devel openssl openssl-devel tcl
# usedforbuild    aaa_base acl attr bash bind9-utils bison coreutils cpio cpp cvs cyrus-sasl2 db devs diffutils e2fsprogs file filesystem fillup findutils flex gawk gdbm-devel glibc glibc-devel glibc-locale gpm grep groff gzip info insserv kbd less libacl libattr libgcc libstdc++ libxcrypt m4 make man mktemp modutils ncurses ncurses-devel net-tools netcfg pam pam-devel pam-modules patch permissions ps rcs readline sed sendmail shadow strace syslogd sysvinit tar texinfo timezone unzip util-linux vim zlib zlib-devel autoconf automake binutils bzip2 cracklib expect gcc gdbm gettext heimdal-lib libtool openldap2 openldap2-client openldap2-devel openssl openssl-devel perl rpm tcl

Name:         gpg
Version:      1.2.2rc1
Release:      98
%define	pversion	1.2.1
License:      GPL
Group:        Productivity/Security
%if %suse_version > 811
PreReq:       %install_info_prereq
%endif
Provides:     gnupg pgpgpg 
Autoreqprov:  on
Summary:      The GNU Privacy Guard. Encrypts, decrypts, and signs data
Source:       ftp://ftp.gnupg.de/pub/gcrypt/gnupg/gnupg-%{pversion}.tar.bz2
Source2:      ftp://ftp.gnupg.de/pub/gcrypt/pgpgpg/pgpgpg-0.13.tar.gz
Source3:      README.SuSE
Source4:      ftp://ftp.gnupg.de/pub/gcrypt/gnupg/gnupg-%{pversion}.tar.bz2.sig
Patch1:       pgpgpg.dif
Patch4:       gpg-encrypt-to-opt.diff
Patch6:       gnupg-%{pversion}.maxkeysize-msg.diff
Patch8:       gnupg-%{pversion}.photoviewer.diff
Patch9:       gnupg-%{pversion}.ppc64-auto.diff
Patch10:      gnupg-%{pversion}.setlocale.diff
Patch12:      gnupg-%{pversion}.use-agent.diff
Patch14:      gnupg-%{pversion}-nokeyid.diff
Patch20:      gnupg-%{pversion}-1.2.2rc1.diff.gz
Patch21:      gnupg-1.2.2rc1-SuSE.diff
Patch30:      gnupg-uidtrustfix.diff
Patch31:      gnupg-1.2.x-gpgkeys-hkp-fmtstr.diff
Patch32:      gnupg-1.2.x-disable-elgamal20.diff
URL:          http://www.gnupg.de
Prefix:       /usr
BuildRoot:    %{_tmppath}/%{name}-%{version}-build

%description
The GNU Privacy Guard is an OpenPGP (RFC2440) implementation. It allows
encryption, decryption, and signatures of data and contains strong
cryptographic algorithms. It is most often used with Mail. It is not to
be (re)exported from the US! It is not to be used in certain countries.
Please check the laws! As of version 1.0.3, support for RSA has been
integrated into GnuPG, as the patent encumbrance expired 2000-09-20. If
you want to read PGP2 encrypted mail, you still need to install
gpgaddon for idea support.



Authors:
--------
    Werner Koch <werner.koch@guug.de>

%prep
#gpg --verify %SOURCE4
%setup -n gnupg-%{pversion} -b 2
%patch4 -p1
%patch6 -p1
%patch8 -p1
%patch9 -p1 -b .auto
%patch10 -p1
%patch12 -p1
%patch14 -p1
zcat %PATCH20 | patch -p1
%patch21 -p1
%patch30 -p0
%patch31 -p1
%patch32 -p1
chown 0.0 -R *
cd ../pgpgpg-0.13
%patch1
# Needed for CVS version
#cd ../gnupg-%{version}
#aclocal
#autoheader
#automake
#autoconf

%build
CFLAGS="$RPM_OPT_FLAGS" \
	./configure  --enable-ldap --enable-external-hkp --enable-shared --with-gnu-ld --enable-static-rnd=linux \
	--prefix=/usr --mandir=%{_mandir} --infodir=%{_infodir} --libdir=%{_libdir} \
	--libexecdir=%{_libdir} --program-prefix="" %{_target_cpu}-suse-linux
#CFLAGS+=--with-capabilities
make
#make -C doc
make check
cd ../pgpgpg-0.13
CFLAGS="$RPM_OPT_FLAGS"  ./configure --prefix=/usr --with-gpg-path=/usr/bin/gpg \
	--mandir=%{_mandir} --infodir=%{_infodir} --libdir=%{_libdir} --program-prefix="" %{_target_cpu}-suse-linux
make

%install
make install DESTDIR=$RPM_BUILD_ROOT
gzip -9f $RPM_BUILD_ROOT%{_mandir}/man1/gpg.1
gzip -9f $RPM_BUILD_ROOT%{_mandir}/man1/gpgv.1
#install -m 644 -o root -g root $RPM_SOURCE_DIR/gpg.1.gz $RPM_BUILD_ROOT%{_mandir}/man1/
install -d $RPM_BUILD_ROOT%{_docdir}/gpg
for name in ABOUT-NLS AUTHORS BUGS COPYING INSTALL NEWS PROJECTS README THANKS TODO VERSION 
do cp -p $name $RPM_BUILD_ROOT%{_docdir}/gpg/; done
sed 's#../g10/##' < scripts/convert-from-106 >$RPM_BUILD_ROOT/usr/bin/gpg-convert-from-106
cd doc
for name in DETAILS FAQ HACKING OpenPGP faq.html samplekeys.asc
do cp -p $name $RPM_BUILD_ROOT%{_docdir}/gpg/; done
#cp -p $RPM_SOURCE_DIR/gnupg-%{version}.security-patch1.diff $RPM_BUILD_ROOT%{_docdir}/gpg/
cd ../../pgpgpg-0.13
make install DESTDIR=$RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT%{_docdir}/gpg/pgpgpg
for name in AUTHORS COPYING ChangeLog INSTALL INSTALL.generic LICENSE NEWS OBUGS README THANKS TODO VERSION
do cp -p $name $RPM_BUILD_ROOT%{_docdir}/gpg/pgpgpg/; done
install -o root -g root -m 644 $RPM_SOURCE_DIR/README.SuSE $RPM_BUILD_ROOT%{_docdir}/gpg/
# !!! ru.po is too buggy !!!
#rm $RPM_BUILD_ROOT/usr/share/locale/ru/LC_MESSAGES/gnupg.mo
# Prevent ldap dependencies to be picked up by find-requires
chmod 0644 $RPM_BUILD_ROOT/%{_libdir}/gnupg/gpgkeys_ldap

%files
%defattr(-,root,root)
/usr/bin/gpg
#%attr (4755,root,root) /usr/bin/gpg
/usr/bin/gpgv
/usr/bin/gpgsplit
%attr(755,root,root) /usr/bin/gpg-convert-from-106
#%{_libdir}/gnupg
%attr(755,root,root) %{_libdir}/gnupg/gpgkeys_mailto
%attr(755,root,root) %{_libdir}/gnupg/gpgkeys_hkp
%attr(755,root,root) %{_libdir}/gnupg/gpgkeys_ldap
/usr/share/gnupg
%{_mandir}/man1/gpg.1.gz
%{_mandir}/man1/gpgv.1.gz
%{_mandir}/man7/gnupg.7.gz
#%{_mandir}/man1/gpgsplit.1.gz
%doc %{_docdir}/gpg
%doc %{_infodir}/gpg.info.gz
%doc %{_infodir}/gpgv.info.gz
/usr/share/locale/*/LC_MESSAGES/gnupg.mo
/usr/bin/pgpgpg

%clean
test ! -z "$RPM_BUILD_ROOT" -a "$RPM_BUILD_ROOT" != "/" && rm -rf $RPM_BUILD_ROOT
rm -rf $RPM_BUILD_DIR/gnupg-%{pversion}
rm -rf $RPM_BUILD_DIR/pgpgpg-0.13

%post
%if %suse_version > 811
%install_info --info-dir=%{_infodir} %{_infodir}/gpg.info.gz
%install_info --info-dir=%{_infodir} %{_infodir}/gpgv.info.gz
%endif

%postun
%if %suse_version > 811
%install_info_delete --info-dir=%{_infodir} %{_infodir}/gpg.info.gz
%install_info_delete --info-dir=%{_infodir} %{_infodir}/gpgv.info.gz
%endif

%changelog -n gpg
* Thu Nov 27 2003 - garloff@suse.de
- Fix format string bug in HKP keyserver module.
- Disable possibility to create ElGamal type 20 (sign+encrypt) keys
  as they are vulnerable to attacks. [#33369]
* Tue Jul 08 2003 - garloff@suse.de
- Handle NULL keyid (symmetric decryption) if use-agent is enabled
  (used to SIGSEGV)
* Fri Jun 06 2003 - garloff@suse.de
- Fix for bug #27242: The trust path did not check for the given
  user-ID but the most trusted one belonging to the same keyID,
  and consequently failed to display a warning when encrypting
  to (or verifying a signature from) an untrusted UID.
- %%install_info --delete %%preun -> %%install_info_delete %%postun
* Wed Feb 26 2003 - garloff@suse.de
- Report version number 1.2.2-rc1-SuSE
- Change defaults to have use-agent enabled
- photo-viewer settings: default to kfmclient openURL
* Wed Feb 19 2003 - garloff@suse.de
- Disable %%install_info for older distros.
- Install convert-from-106 into /usr/bin/gpg-convert-from-106
* Tue Feb 18 2003 - garloff@suse.de
- Update to 1.2.2rc1:
  * convert-from-106 script to help trustdb conversion
  * notation names should have @ (need --expert to override)
  * --trust-model always for forward(!) compatibility
  * Prevent compiler from optimizing away memory wiping code
  * Skip disabled keys in selection for encryption
  * Minor trustdb tweaks
  * New translations: Finnish, Trad. Chinese
- Enable external hkp interface (for gpgme/3rd party software)
* Thu Feb 06 2003 - ro@suse.de
- use macros for install-info
* Thu Oct 31 2002 - ro@suse.de
- re-enable autoreqprov: all required libs are part of the
  minimal system
* Wed Oct 30 2002 - garloff@suse.de
- Avoid dependencies triggered by LDAP module.
* Wed Oct 30 2002 - garloff@suse.de
- Update README.SuSE
- Update to GnuPG-1.2.1:
  * mark secret keys generated by --export-secret-keys with # (key
  listing) resp. no capabilites (colon listing)
  * option --trusted-key is not obsolete any more
  * bugfixes, e.g. a recursion when reading keys for trust check
- Compile with support for LDAP (openldap2) keyservers.
* Fri Oct 04 2002 - garloff@suse.de
- Move libexec to _libdir instead of share, because the plugins
  will also be there.
* Fri Sep 27 2002 - garloff@suse.de
- Use install-info in %%post and %%preun (and add acc. PreReq)
- Move /usr/libexec/gnupg/gpg_keys_mailto to /usr/share/gnupg/
  (it's a perl script)
- Update to GnuPG-1.2.0:
  http://lists.gnupg.org/pipermail/gnupg-announce/2002q3/000252.html
  * Better docu (new gnupg(7) manpage, gpgv info file)
  * options file move to ~/.gnupg/gpg.conf
  * Modules linked statically (except for deprecated idea plugin)
  * Restrictions executing other helper programs configurable
  * group command to work with several keys
  * --interactive works as expected when importing keys now
  * Full revocation key support
  * export option leaving off attribute packets (e.g. photo ID
  to not confuse keyservers)
  * Workaround for HKP server subkey mangling bug in --import
  * --atribute-fd support (photo ID)
  * ElGamal encrypt AND sign as well as RSA E&S only available
  in expert mode key generation
  * MDC use increased
  * preferred hash algos of a key are respected
  * --pgp7 option sets all parameters for maximum PGP7 compat
  * Permission/Ownership checks of keyrings clarified
  * LDAP v1 keyserver support
  * v3 keys can be self-signed with v4 signatures (for prefs)
  * Default character set taken from current locale
* Fri Jul 26 2002 - adrian@suse.de
- fix neededforbuild
* Tue Jun 18 2002 - meissner@suse.de
- powerpc64 is powerpc64, fixed MPI asm links.
* Mon May 13 2002 - garloff@suse.de
- Fix german --keyserver-options help text.
* Sat May 11 2002 - garloff@suse.de
- Update to gpg-1.0.7: See
  http://lists.gnupg.org/pipermail/gnupg-announce/2002q2/000251.html
  * Secret keys are now SHA-1 protected (protection against Rosa/
  Klima attacks). --simple-sk-checksum disables this.
  * Default cipher now CAST5, hash SHA-1.
  * Symmetric encrypted messages use fixed file size if possible.
  (Improved compatibility with PGP2,6,7; breaks PGP5.)
  * Photographic user ID support (external viewer required).
  * Enhanced keyserver support via plugins (NAI LDAP, HKP email).
  * Support nonrevocable signatures (be careful!).
  * Multiple signature classes.
  * --pgp2,--pgp6 modes for messages to PGP2/6 users.
  * Signatures can have expiration date as well now.
  * Designated revocation keys supported (can not yet be generated
  though).
  * Permission checks for ~/.gnupg/ directory.
  * New tool gpgsplit.
  * Command "primary" in the edit menu to change primary UID.
  * RSA key generation supported.
  * Keyring managemanet reworked.
  * Signature status storage changed. (Use --rebuild-keydb-caches).
  * Key validation process (trustdb) reworked. See man page entries
  for --update-trustdb, --check-trustdb and
--no-auto-check-trustdb
  * Read-only keyrings now handled as expected.
  * Many more ...
- Default RSA keysize to 1536 (instead of 1024)
- Default Photo ID viewer to kview (instead of xloadimage)
* Sat May 11 2002 - garloff@suse.de
- Add two patches for 1.0.6 from Werner Koch (for Woody):
  * RNG fix (non critical)
  * compatibility with keyrings produced with 1.0.6b or later
* Mon Sep 10 2001 - garloff@suse.de
- Fixed typos in README.SuSE
- Fix message telling user about allowed keysizes for the DSA case
  (bug #9295).
* Thu May 31 2001 - draht@suse.de
- update to 1.0.6 to fix the do_get format string error
  ru locale is gone.
* Fri May 18 2001 - garloff@suse.de
- Many more problems found and (partially) corrected in the
  translations (.po files) which could lead to similar trouble.
- Disabled ru translations as they are too buggy for me to fix.
* Wed May 16 2001 - garloff@suse.de
- Fix bug in tr locale triggered by gpg -v (bugzilla #8457)
* Tue May 08 2001 - garloff@suse.de
- Put (commented out) encrypt-to option in options skeleton to
  help users finding a way to read their encrypted mail ...
* Sun Apr 29 2001 - garloff@suse.de
- Update to 1.0.5:
  * Bugfixes and translations in addition to 1.0.4h changes.
* Fri Apr 20 2001 - garloff@suse.de
- Update to gnupg-1.0.4h:
  * gpg could segfault on --check-sigs in fixup_uidnode, if
  either uid of sig are 0.
* Thu Apr 12 2001 - garloff@suse.de
- Update to 1.0.4g:
  * includes the security patches (secret key import, detached
  signature checking)
  * More bugfixes
  * time.h fixes already included
  * Warn user if signing with invalid signature (which prevents
  the attack by altering the secret key)
* Wed Feb 07 2001 - pthomas@suse.de
- If system supports LC_MESSAGES, set LC_CTYPE along with
  LC_MESSAGES. Required for correct i18n support in glibc2.2.
- Include time.h where necessary.
* Fri Dec 15 2000 - garloff@suse.de
- Include patch to require --allow-secret-key-import. Secret keys
  are no longer silently imported.
* Wed Dec 06 2000 - bk@suse.de
- add /usr/lib/gnupg and /usr/share/gnupg to %%files(obsoletes /*'s)
- doc: %%doc %%{_docdir}/gpg adds %%{_docdir}/gpg to %%files, marks
  everything below it as documentation(obsoletes other %%doc macros)
* Fri Dec 01 2000 - garloff@suse.de
- Added gnupg-1.0.4.security-patch1.diff from GnuPG site:
  When checking detached signatures, gnupg could have been make
  believe that the sig file contains the text to be checked,
  so the real text would not have been checked :-(
* Tue Oct 24 2000 - garloff@suse.de
- Put it as updates on ftp servers.
* Mon Oct 23 2000 - garloff@suse.de
- Update to GnuPG-1.0.4:
  * GnuPG <= 1.0.3 did incorrectly report messages with multiple
  signatures to be correct, even if some sigs are not.
  Fixed.
  * Rijndael support.
  * gpgv binary to just check signatures.
* Tue Sep 19 2000 - garloff@suse.de
- Update to GnuPG-1.0.3: Bugfixes:
  * --trusted-key option
  * expiration time of primary key can be changed again
  * display Revoked with --list-key (if appropriate)
  New features:
  * --merge-only, --try-all-secrets
  * Twofish and MDC support
  * faq.html
  and last but not least:
  * RSA support
* Wed Aug 09 2000 - garloff@suse.de
- Update to 1.0.2 (Finally get rid of the devel version)
- Updated README.
* Sat Jun 17 2000 - garloff@suse.de
- Added tcl & expect to neededforbuild (needed for the checks)
* Wed May 24 2000 - garloff@suse.de
- Disable DEVELOPMENT VERSION warning
* Fri May 19 2000 - garloff@suse.de
- Added BuildRoot.
* Fri May 19 2000 - garloff@suse.de
- Fixed usage of %%{_docdir}
* Fri May 19 2000 - garloff@suse.de
- Update to 1.01e-SuSE.
- Moved docs to %%{_docdir}.
* Sat Mar 04 2000 - garloff@suse.de
- Fixed typo in german translation.
- Version renamed to 1.0.1c-SuSE.
* Sun Feb 27 2000 - garloff@suse.de
- Fixed perms of README.SuSE 755->644.
* Tue Feb 22 2000 - garloff@suse.de
- Updated to 1.0.1c (test version) after a discussion with WK.
  Last workaround obsoleted by that.
* Mon Feb 21 2000 - garloff@suse.de
- Turned a fatal error (gpg: 231: read expected rec type 3, got 6)
  into a warning.
* Sat Feb 05 2000 - garloff@suse.de
- Moved manpages to /usr/share/man.
* Wed Jan 05 2000 - garloff@suse.de
- Upgrade to version 1.0.1.
* Wed Oct 13 1999 - garloff@suse.de
- Back to 1.0.0. Developers obviously don't want us to use devel
  versions.
* Wed Oct 13 1999 - garloff@suse.de
- Upgrade to 1.0.0e. Fixed typos in README.SuSE.
* Fri Sep 24 1999 - garloff@suse.de
- Fixed filelist.
* Wed Sep 22 1999 - garloff@suse.de
- Upgraded to version 1.0.0. Updated source locations.
  Added README.SuSE.
* Mon Sep 13 1999 - bs@suse.de
- ran old prepare_spec on spec file to switch to new prepare_spec.
* Mon Aug 23 1999 - garloff@suse.de
- Initial check in of gpg-0.9.10 and pgpgpg-0.13
